Tool: list_metric_descriptors
Use this as the primary tool to discover the types of metrics available in a Google Cloud project. This is a good first step to understanding what data is available for monitoring and building dashboards or alerts.
The following sample demonstrate how to use curl to invoke the list_metric_descriptors MCP tool.
| Curl Request |
|---|
curl --location 'https://monitoring.googleapis.com/mcp' \ --header 'content-type: application/json' \ --header 'accept: application/json, text/event-stream' \ --data '{ "method": "tools/call", "params": { "name": "list_metric_descriptors", "arguments": { // provide these details according to the tool's MCP specification } }, "jsonrpc": "2.0", "id": 1 }' |
Input Schema
The ListMetricDescriptors request.
ListMetricDescriptorsRequest
| JSON representation |
|---|
{ "name": string, "filter": string, "pageSize": integer, "pageToken": string, "activeOnly": boolean } |
| Fields | |
|---|---|
name |
Required. The project on which to execute the request. The format is: |
filter |
Optional. If this field is empty, all custom and system-defined metric descriptors are returned. Otherwise, the filter specifies which metric descriptors are to be returned. For example, the following filter matches all custom metrics: |
pageSize |
Optional. A positive number that is the maximum number of results to return. The default and maximum value is 10,000. If a page_size <= 0 or > 10,000 is submitted, will instead return a maximum of 10,000 results. |
pageToken |
Optional. If this field is not empty then it must contain the |
activeOnly |
Optional. If true, only metrics and monitored resource types that have recent data (within roughly 25 hours) will be included in the response. - If a metric descriptor enumerates monitored resource types, only the monitored resource types for which the metric type has recent data will be included in the returned metric descriptor, and if none of them have recent data, the metric descriptor will not be returned. - If a metric descriptor does not enumerate the compatible monitored resource types, it will be returned only if the metric type has recent data for some monitored resource type. The returned descriptor will not enumerate any monitored resource types. |
Output Schema
The ListMetricDescriptors response.
ListMetricDescriptorsResponse
| JSON representation |
|---|
{
"metricDescriptors": [
{
object ( |
| Fields | |
|---|---|
metricDescriptors[] |
The metric descriptors that are available to the project and that match the value of |
nextPageToken |
If there are more results than have been returned, then this field is set to a non-empty value. To see the additional results, use that value as |
MetricDescriptor
| JSON representation |
|---|
{ "name": string, "type": string, "labels": [ { object ( |
| Fields | |
|---|---|
name |
The resource name of the metric descriptor. |
type |
The metric type, including its DNS name prefix. The type is not URL-encoded. All user-defined metric types have the DNS name |
labels[] |
The set of labels that can be used to describe a specific instance of this metric type. For example, the |
metricKind |
Whether the metric records instantaneous values, changes to a value, etc. Some combinations of |
valueType |
Whether the measurement is an integer, a floating-point number, etc. Some combinations of |
unit |
The units in which the metric value is reported. It is only applicable if the Different systems might scale the values to be more easily displayed (so a value of If you want a custom metric to record the exact number of CPU-seconds used by a job, you can create an Alternatively, if you want a custom metric to record data in a more granular way, you can create a The supported units are a subset of The Unified Code for Units of Measure standard: Basic units (UNIT)
Prefixes (PREFIX)
Grammar The grammar also includes these connectors:
The grammar for a unit is as follows: Notes:
|
description |
A detailed description of the metric, which can be used in documentation. |
displayName |
A concise name for the metric, which can be displayed in user interfaces. Use sentence case without an ending period, for example "Request count". This field is optional but it is recommended to be set for any metrics associated with user-visible concepts, such as Quota. |
metadata |
Optional. Metadata which can be used to guide usage of the metric. |
launchStage |
Optional. The launch stage of the metric definition. |
monitoredResourceTypes[] |
Read-only. If present, then a |
LabelDescriptor
| JSON representation |
|---|
{
"key": string,
"valueType": enum ( |
| Fields | |
|---|---|
key |
The key for this label. The key must meet the following criteria:
|
valueType |
The type of data that can be assigned to the label. |
description |
A human-readable description for the label. |
MetricDescriptorMetadata
| JSON representation |
|---|
{ "launchStage": enum ( |
| Fields | |
|---|---|
launchStage |
Deprecated. Must use the |
samplePeriod |
The sampling period of metric data points. For metrics which are written periodically, consecutive data points are stored at this time interval, excluding data loss due to errors. Metrics with a higher granularity have a smaller sampling period. A duration in seconds with up to nine fractional digits, ending with ' |
ingestDelay |
The delay of data points caused by ingestion. Data points older than this age are guaranteed to be ingested and available to be read, excluding data loss due to errors. A duration in seconds with up to nine fractional digits, ending with ' |
timeSeriesResourceHierarchyLevel[] |
The scope of the timeseries data of the metric. |
Duration
| JSON representation |
|---|
{ "seconds": string, "nanos": integer } |
| Fields | |
|---|---|
seconds |
Signed seconds of the span of time. Must be from -315,576,000,000 to +315,576,000,000 inclusive. Note: these bounds are computed from: 60 sec/min * 60 min/hr * 24 hr/day * 365.25 days/year * 10000 years |
nanos |
Signed fractions of a second at nanosecond resolution of the span of time. Durations less than one second are represented with a 0 |
Tool Annotations
Destructive Hint: ❌ | Idempotent Hint: ✅ | Read Only Hint: ✅ | Open World Hint: ❌